/*
 * X80ControlDemo.java
 *
 * Created on July 22, 2007, 12:59 AM
 */

package DrRobot.X80Control;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;
/**
 *
 * @author  Bo Wei
 */
public class X80ControlDemo extends javax.swing.JFrame {
    private Timer timer = null;
    private ActionListener actionListener;
   
    private static int DisplayCnt = 0;
    private robotSocket sock = null;
    private String robotIP ="";
    private int robotPort =0;
   
    private boolean ConnectFlag = false;
    
   
   //for DC Motor Demo Task timer
    private Timer tmrDCMotorDemo = null;
    private ActionListener DCMotorDemoListener;
    private int DCMotorDemoStep = 0;
    
    //for servo Demo Task timer
    private Timer tmrServoDemo = null;
    private ActionListener ServoDemoListener;
    private int ServoDemoStep = 0;
    
    /** Creates new form X80ControlDemo */
    //here is some import const refere protocol
    final byte STX0 = 94;
    final byte STX1 = 2;
    final byte ETX0 = 94;
    final byte ETX1 = 13;
    
    final byte SPEEDMOVE = 27;      //refere protocol
    final byte ENDCMOTOR = 30;      //Enable or Disable DC motor
    final byte SERVOCTRL = 28;      //servo control
    final byte SERVOCTRLALL = 29;   //6 servo control
    final byte DCMOTORPOSITION = 4;     //DC motor positon control
    final byte DCMOTORPARAMETERSET = 7; //

    final byte DCMOTORCTRLMODE = 14;    //
    
    final byte DCPOSITIONPID = 7;      //positon PID Control
    final byte DCVELOCITYPID = 8;      //velocity PID Control
    
    final byte PWMCTRL = 0;
    final byte POSITIONCTRL = 1;
    final byte VELOCITYCTRL = 2;
    
    final byte KpID = 1;
    final byte KdID = 2;
    final byte KiID = 3;
    
    final int NONCTRLCMD = 0xffff;      //no ctrl command
    
    //some robot parameters, depend on what kind of robot you rae using, here is for X80, if you have some questions,please send e-mail to info@drrobot.com
    final double WheelDis = 0.265;      //wheel distance
    final double WheelR = 0.0825;       //wheel radius
    final int CircleCnt = 1200;     //encoder one circle count
    
    public X80ControlDemo() {
      initComponents();
      
      
        
      ActionListener actionListener = new ActionListener() {
                     public void actionPerformed(ActionEvent actionEvent) {
                            //display sensor data here
                         DisplayCnt++;
                         jLabel16.setText((Integer.toString(DisplayCnt)));
                         if (ConnectFlag == true){
                            sock.run();
                            //first display motor sensor
                            jLabel_LeftMotorPos.setText(Integer.toString(sock.EncoderPos[0]));
                            jLabel_RightMotorPos.setText(Integer.toString(sock.EncoderPos[1]));
                            jLabel_LeftMotorSpeed.setText(Integer.toString(sock.EncoderSpeed[0]));
                            jLabel_RightMotorSpeed.setText(Integer.toString(sock.EncoderSpeed[1]));
                            jLabel_LeftMotorCurrent.setText(Double.toString(sock.MotorCurrent[0]));
                            jLabel_RightMotorCurrent.setText(Double.toString(sock.MotorCurrent[1]));
                            
                            
                            //IR Sensor 
                            jLabel_IRDis1.setText(Double.toString(sock.IRDis[0]));
                            jLabel_IRDis2.setText(Double.toString(sock.IRDis[1]));
                            jLabel_IRDis3.setText(Double.toString(sock.IRDis[2]));
                            jLabel_IRDis4.setText(Double.toString(sock.IRDis[3]));
                            jLabel_IRDis5.setText(Double.toString(sock.IRDis[4]));
                            jLabel_IRDis6.setText(Double.toString(sock.IRDis[5]));
                            jLabel_IRDis7.setText(Double.toString(sock.IRDis[6]));
                            //US Sensor
                            jLabel_USDis1.setText(Double.toString(sock.USDis[0]));
                            jLabel_USDis2.setText(Double.toString(sock.USDis[1]));
                            jLabel_USDis3.setText(Double.toString(sock.USDis[2]));
                            jLabel_USDis4.setText(Double.toString(sock.USDis[3]));
                            jLabel_USDis5.setText(Double.toString(sock.USDis[4]));
                            jLabel_USDis6.setText(Double.toString(sock.USDis[5]));
                            //Human Sensor
                            jLabel_HumanAlarm1.setText(Integer.toString(sock.HumanAlarm[0]));
                            jLabel_HumanAlarm2.setText(Integer.toString(sock.HumanAlarm[1]));
                            jLabel_HumanMotion1.setText(Integer.toString(sock.HumanMotion[0]));
                            jLabel_HumanMotion2.setText(Integer.toString(sock.HumanMotion[1]));
                            
                            //Board Vol
                            jLabel_BoardVol.setText(Double.toString(sock.BoardVol));
                            jLabel_MotorVol.setText(Double.toString(sock.DCMotorVol));
                            
                         }
                    }   
                 };
    timer  = new Timer(20, actionListener);
    timer.start();
 
    ActionListener DCMotorDemoListener = new ActionListener() {
         public void actionPerformed(ActionEvent actionEvent){
              DCMotorDemoStep ++;
              if (DCMotorDemoStep == 1){
                  turnStep(90);
              }
              else if(DCMotorDemoStep == 2){
                  runStep(1.0);
              }
              else if(DCMotorDemoStep == 3){
                  turnStep(90.0);
              }
              else if(DCMotorDemoStep == 4){
                  runStep(1.0);
              }
              else if(DCMotorDemoStep == 5){
                  turnStep(90);
              }
              else if(DCMotorDemoStep == 6){
                  runStep(1.0);
              }
              else if(DCMotorDemoStep == 7){
                  turnStep(90);
              }
              else if(DCMotorDemoStep == 8){
                  DCMotorDemoStep = -1;     //means stop
                  tmrDCMotorDemo.stop();
              }
              jLabel_DCMotorDemoStep.setText(Integer.toString(DCMotorDemoStep));
          }
      };
      tmrDCMotorDemo = new Timer(11000,DCMotorDemoListener);
      tmrDCMotorDemo.stop();
    
      ActionListener ServoDemoListener = new ActionListener() {
         public void actionPerformed(ActionEvent actionEvent){
              ServoDemoStep ++;
              if (ServoDemoStep == 1){
                  ServoTimeCtrAll(4200,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 2){
                  ServoTimeCtrAll(2400,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 3){
                  ServoTimeCtrAll(4200,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 4){
                  ServoTimeCtrAll(2400,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 5){
                  ServoTimeCtrAll(3500,2400,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 6){
                  ServoTimeCtrAll(3500,4400,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 7){
                  ServoTimeCtrAll(3500,2400,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 8){
                  ServoTimeCtrAll(3500,4400,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 9){
                  ServoTimeCtrAll(3500,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,1500);
              }
              else if(ServoDemoStep == 10){
                  ServoDemoStep = -1;     //means stop
                  tmrServoDemo.stop();
              }
              jLabel_ServoDemoStep.setText(Integer.toString(ServoDemoStep));
          }
      };
      tmrServoDemo = new Timer(2000,ServoDemoListener);
      tmrServoDemo.stop();
      }
    
  private void ServoTimeCtrAll(int cmd1, int cmd2, int cmd3, int cmd4, int cmd5, int cmd6, int time) 
{
	// TODO: Add your dispatch handler code here
	byte []msg = new byte[23];

	msg[0] = STX0;  msg[1] = STX1;
	msg[2] = 1;    msg[3] = 0;
	//DID
	msg[4] = SERVOCTRLALL;
	msg[5] = 14;//Length;
	msg[6] = (byte)(cmd1 & 0xff);
        msg[7] = (byte)((cmd1 >>> 8) & 0xff);
        msg[8] = (byte)(cmd2 & 0xff);
        msg[9] = (byte)((cmd2 >>> 8) & 0xff);
        msg[10] = (byte)(cmd3 & 0xff);
        msg[11] = (byte)((cmd3 >>> 8) & 0xff);
        msg[12] = (byte)(cmd4 & 0xff);
        msg[13] = (byte)((cmd4 >>> 8) & 0xff);
        msg[14] = (byte)(cmd5 & 0xff);
        msg[15] = (byte)((cmd5 >>> 8) & 0xff);
        msg[16] = (byte)(cmd6 & 0xff);
        msg[17] = (byte)((cmd6 >>> 8) & 0xff);
        msg[18] = (byte)(time & 0xff);
        msg[19] = (byte)((time >>> 8) & 0xff);
	
	msg[20] =calc_CRC_bit(msg);//Checksum

	msg[21] = ETX0; msg[22] = ETX1;

	sock.sendCommand(msg);

}

    
    private void DisableDCMotor(byte channel){
        //Disable DCmotor command
        byte []DisableDCMotorCmd = new byte[11];
        DisableDCMotorCmd[0] = STX0;
        DisableDCMotorCmd[1] = STX1;
        DisableDCMotorCmd[2] = 1;
        DisableDCMotorCmd[3] = 0;
        DisableDCMotorCmd[4] = ENDCMOTOR;       //DID
        DisableDCMotorCmd[5] = 2;
        DisableDCMotorCmd[6] = 0;           //Disable
        DisableDCMotorCmd[7] = channel;           //channel
        DisableDCMotorCmd[8] = calc_CRC_bit(DisableDCMotorCmd);           //check sum
        DisableDCMotorCmd[9] = ETX0;
        DisableDCMotorCmd[10] = ETX1;
        sock.sendCommand(DisableDCMotorCmd);
    }
   
    private void ServoTimeCtrl(byte channel,int cmdValue, int timeValue){
        byte []ServoCtrlCmd;
        ServoCtrlCmd = new byte[15];
        ServoCtrlCmd[0] = STX0;
        ServoCtrlCmd[1] = STX1;
        ServoCtrlCmd[2] = 1;
        ServoCtrlCmd[3] = 0;
        ServoCtrlCmd[4] = SERVOCTRL;        //28 servo control
        ServoCtrlCmd[5] = 6;                //length
        ServoCtrlCmd[6] = channel;                //channel
        ServoCtrlCmd[7] = (byte)(cmdValue & 0xff);                //command value low 8 bit
        ServoCtrlCmd[8] = (byte)((cmdValue >>> 8) & 0xff);                //high 8 bit
        ServoCtrlCmd[9] = 28;               //flag
        ServoCtrlCmd[10] = (byte)(timeValue & 0xff);               //time low 8 bit
        ServoCtrlCmd[11] = (byte)((timeValue >>> 8) & 0xff);               //high 8 bit    
        ServoCtrlCmd[12] = calc_CRC_bit(ServoCtrlCmd);               //check sum
        ServoCtrlCmd[13] = ETX0;
        ServoCtrlCmd[14] = ETX1;
        sock.sendCommand(ServoCtrlCmd);
    }
    
    private void SpeedNonTimeCtrlAll(int cmd1,int cmd2,int cmd3,int cmd4,int cmd5,int cmd6){
        byte []DCMotorSpeedCmd;
        DCMotorSpeedCmd = new byte[21];
        DCMotorSpeedCmd[0] = STX0;
        DCMotorSpeedCmd[1] = STX1;
        DCMotorSpeedCmd[2] = 1;
        DCMotorSpeedCmd[3] = 0;
        DCMotorSpeedCmd[4] = SPEEDMOVE;     //DID
        DCMotorSpeedCmd[5] = 12;            //length
        DCMotorSpeedCmd[6] = (byte)(cmd1 & 0xff);             //motor 1
        DCMotorSpeedCmd[7] = (byte) ( (cmd1 >>> 8) & 0xff);             
        DCMotorSpeedCmd[8] = (byte)(cmd2 & 0xff);             //motor 2
        DCMotorSpeedCmd[9] = (byte)((cmd2 >>> 8) & 0xff);
        DCMotorSpeedCmd[10] = (byte)(cmd3 & 0xff);            //motor 3
        DCMotorSpeedCmd[11] = (byte)( (cmd3 >>> 8) & 0xff);
        DCMotorSpeedCmd[12] = (byte)(cmd4 & 0xff);            //motor 4
        DCMotorSpeedCmd[13] = (byte)((cmd4 >>> 8) & 0xff);
        DCMotorSpeedCmd[14] = (byte)(cmd5 & 0xff);           //motor 5
        DCMotorSpeedCmd[15] = (byte) ((cmd5 >>> 8) & 0xff);           
        DCMotorSpeedCmd[16] = (byte)(cmd6 & 0xff);           //motor 6
        DCMotorSpeedCmd[17] = (byte)((cmd6 >>> 8) & 0xff);            
        DCMotorSpeedCmd[18] = calc_CRC_bit(DCMotorSpeedCmd);            //check sum
        DCMotorSpeedCmd[19] = ETX0;
        DCMotorSpeedCmd[20] = ETX1;
        sock.sendCommand(DCMotorSpeedCmd);
    }
    
    
    private void DCMotorPositionTimeCtrlAll(int cmd1, int cmd2, int cmd3, int cmd4, int cmd5, int cmd6,int time){
	byte []msg = new byte[23];
	msg[0] = STX0;  msg[1] = STX1;
	msg[2] = 1;   msg[3] = 0;
	msg[4] = DCMOTORPOSITION;       //DID
	msg[5] = 14;//Length;
        msg[6] = (byte)(cmd1 & 0xff);               //channel 1
        msg[7] = (byte)((cmd1 >>> 8) & 0xff);
        msg[8] = (byte)(cmd2 & 0xff);               //channel 2
        msg[9] = (byte)((cmd2 >>> 8) & 0xff);
        msg[10] = (byte)(cmd3 & 0xff);               //channel 3
        msg[11] = (byte)((cmd3 >>> 8) & 0xff);
        msg[12] = (byte)(cmd4 & 0xff);               //channel 4
        msg[13] = (byte)((cmd4 >>> 8) & 0xff);
        msg[14] = (byte)(cmd5 & 0xff);               //channel 5
        msg[15] = (byte)((cmd5 >>> 8) & 0xff);
        msg[16] = (byte)(cmd6 & 0xff);               //channel 6
        msg[17] = (byte)((cmd6 >>> 8) & 0xff);
		
	msg[18] = (byte)(time & 0xff);
	msg[19] = (byte)( (time >>> 8) & 0x0ff);
	
	msg[20] = calc_CRC_bit(msg);//Checksum

	msg[21] = ETX0; msg[22] = ETX1;
        sock.sendCommand(msg);
    }
    
    private void SetDcMotorControlMode(byte channel, byte controlMode) 
{
	byte []msg = new byte[12];

	msg[0] = STX0; msg[1] = STX1;
	msg[2] = 1;		msg[3] = 0;
	//DID
	msg[4] = DCMOTORPARAMETERSET;

	msg[5] = 3;//Length;

	msg[6] = DCMOTORCTRLMODE;
	
	msg[7] = channel;//Channel

	msg[8] = controlMode;       //0 -- PWM control, 1 -- positoin control, 2 -- velocity control
	

	msg[9] = calc_CRC_bit(msg);//Checksum

	msg[10] = ETX0; msg[11] = ETX1;

	sock.sendCommand(msg);

}
    
    private void SetDcMotorPositionControlPID(byte channel, int Kp, int Kd, int Ki) 
{
	byte []msg = new  byte[20];

	msg[0] = STX0;          msg[1] = STX1;
	msg[2] = 1;		msg[3] = 0;
	//DID
	msg[4] = DCMOTORPARAMETERSET;
	msg[5] = 11;//Length;
	msg[6] = DCPOSITIONPID;
	msg[7] = channel;
	msg[8] = KpID;
        msg[9] = (byte)( Kp & 0xff);
        msg[10] = (byte)( ( Kp >>> 8) & 0xff);
	msg[11] = KdID;
        msg[12] = (byte)( Kd & 0xff);
        msg[13] = (byte)( ( Kd >>> 8) & 0xff);
	msg[14] = KiID;
        msg[15] = (byte)( Ki & 0xff);
        msg[16] = (byte)( ( Ki >>> 8) & 0xff);

	msg[17] = calc_CRC_bit(msg);//Checksum

	msg[18] = ETX0; msg[19] = ETX1;

	sock.sendCommand(msg);

}

    private void SetDcMotorVelocityControlPID(byte channel, int Kp, int Kd, int Ki) 
{
	byte []msg = new  byte[20];

	msg[0] = STX0;          msg[1] = STX1;
	msg[2] = 1;		msg[3] = 0;
	//DID
	msg[4] = DCMOTORPARAMETERSET;
	msg[5] = 11;//Length;
	msg[6] = DCVELOCITYPID;
	msg[7] = channel;
	msg[8] = KpID;
        msg[9] = (byte)( Kp & 0xff);
        msg[10] = (byte)( ( Kp >>> 8) & 0xff);
	msg[11] = KdID;
        msg[12] = (byte)( Kd & 0xff);
        msg[13] = (byte)( ( Kd >>> 8) & 0xff);
	msg[14] = KiID;
        msg[15] = (byte)( Ki & 0xff);
        msg[16] = (byte)( ( Ki >>> 8) & 0xff);

	msg[17] = calc_CRC_bit(msg);//Checksum

	msg[18] = ETX0; msg[19] = ETX1;

	sock.sendCommand(msg);

}
    
    private void runStep(double runDis){
        //the robot will go forward the rundistance
        int diffEncoder = (int)( (runDis / ( 2 * Math.PI * WheelR ) ) * CircleCnt);
        
        int LeftTarget = sock.EncoderPos[0] - diffEncoder;
        if(LeftTarget < 0){
            LeftTarget = 32767 + LeftTarget;
        }
        else if(LeftTarget > 32767 ){
            LeftTarget = LeftTarget - 32767;
        }
        
        int RightTarget = sock.EncoderPos[1] + diffEncoder;
        if(RightTarget > 32767){
            RightTarget =RightTarget - 32767;
        }
        else if(RightTarget < 0){
            RightTarget = 32767 + RightTarget;
        }
        
        
        SetDcMotorControlMode( (byte)0, POSITIONCTRL);
        SetDcMotorControlMode( (byte)1, POSITIONCTRL);
        SetDcMotorPositionControlPID((byte)0,1000,30,2000);
        SetDcMotorPositionControlPID((byte)1,1000,30,2000);
        
        DCMotorPositionTimeCtrlAll(LeftTarget,RightTarget,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,10000);
  
    }
    
    private void turnStep(double angle){
        //the parameter is degree, need transfor to radian
        angle = angle / 180 * Math.PI;
        int diffEncoder = (int)(( ( angle * WheelDis / 2) / (2 * Math.PI * WheelR)) * CircleCnt );
        int LeftTarget = sock.EncoderPos[0] + diffEncoder;
        if(LeftTarget < 0){
            LeftTarget = 32767 + LeftTarget;
        }
        else if(LeftTarget > 32767 ){
            LeftTarget = LeftTarget - 32767;
        }
        
        int RightTarget = sock.EncoderPos[1] + diffEncoder;
        if(RightTarget > 32767){
            RightTarget =RightTarget - 32767;
        }
        else if(RightTarget < 0){
            RightTarget = 32767 + RightTarget;
        }
        
        SetDcMotorControlMode( (byte)0, POSITIONCTRL);
        SetDcMotorControlMode( (byte)1, POSITIONCTRL);
        
        DCMotorPositionTimeCtrlAll(LeftTarget,RightTarget,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,5000);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField_RobotIP = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField_RobotPort = new javax.swing.JTextField();
        jButton_Connect = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel_IR1 = new javax.swing.JLabel();
        jLabel_IRDis1 = new javax.swing.JLabel();
        jLabel_IR2 = new javax.swing.JLabel();
        jLabel_IRDis2 = new javax.swing.JLabel();
        jLabel_IR3 = new javax.swing.JLabel();
        jLabel_IRDis3 = new javax.swing.JLabel();
        jLabel_IR4 = new javax.swing.JLabel();
        jLabel_IRDis4 = new javax.swing.JLabel();
        jLabel_IR5 = new javax.swing.JLabel();
        jLabel_IRDis5 = new javax.swing.JLabel();
        jLabel_IR6 = new javax.swing.JLabel();
        jLabel_IRDis6 = new javax.swing.JLabel();
        jLabel_IR7 = new javax.swing.JLabel();
        jLabel_IRDis7 = new javax.swing.JLabel();
        jLabel_US1 = new javax.swing.JLabel();
        jLabel_USDis1 = new javax.swing.JLabel();
        jLabel_US2 = new javax.swing.JLabel();
        jLabel_USDis2 = new javax.swing.JLabel();
        jLabel_US3 = new javax.swing.JLabel();
        jLabel_USDis3 = new javax.swing.JLabel();
        jLabel_US4 = new javax.swing.JLabel();
        jLabel_USDis4 = new javax.swing.JLabel();
        jLabel_US5 = new javax.swing.JLabel();
        jLabel_USDis5 = new javax.swing.JLabel();
        jLabel_US6 = new javax.swing.JLabel();
        jLabel_USDis6 = new javax.swing.JLabel();
        jLabel_BoardVolDec = new javax.swing.JLabel();
        jLabel_BoardVol = new javax.swing.JLabel();
        jLabel_MotorVolDec = new javax.swing.JLabel();
        jLabel_MotorVol = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel_LeftMotorPos = new javax.swing.JLabel();
        jLabel_RightMotorPos = new javax.swing.JLabel();
        jLabel_LeftMotorSpeed = new javax.swing.JLabel();
        jLabel_RightMotorSpeed = new javax.swing.JLabel();
        jLabel_LeftMotorCurrent = new javax.swing.JLabel();
        jLabel_RightMotorCurrent = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jButton_MoveForward = new javax.swing.JButton();
        jButton_TurnLeft = new javax.swing.JButton();
        jButton_Stop = new javax.swing.JButton();
        jButton_TurnRight = new javax.swing.JButton();
        jButton_MoveBackward = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jSlider_Speed = new javax.swing.JSlider();
        jLabel_Speed = new javax.swing.JLabel();
        jButton_MotorDemo = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        jLabel_DCMotorDemoStep = new javax.swing.JLabel();
        jButton_Forward = new javax.swing.JButton();
        jButton_Turn90 = new javax.swing.JButton();
        jTextField_PosKd = new javax.swing.JTextField();
        jTextField_PosKi = new javax.swing.JTextField();
        jTextField_PosKp = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jTextField_VelKi = new javax.swing.JTextField();
        jTextField_VelKd = new javax.swing.JTextField();
        jTextField_VelKp = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jSlider_HeadTilt = new javax.swing.JSlider();
        jLabel12 = new javax.swing.JLabel();
        jSlider_EyeTilt = new javax.swing.JSlider();
        jLabel13 = new javax.swing.JLabel();
        jSlider_Mouth = new javax.swing.JSlider();
        jLabel14 = new javax.swing.JLabel();
        jSlider_HeadPan = new javax.swing.JSlider();
        jLabel15 = new javax.swing.JLabel();
        jSlider_EyePan = new javax.swing.JSlider();
        jButton_HeadDemo = new javax.swing.JButton();
        jLabel23 = new javax.swing.JLabel();
        jLabel_ServoDemoStep = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel_HumanAlarm1 = new javax.swing.JLabel();
        jLabel_HumanAlarm2 = new javax.swing.JLabel();
        jLabel_HumanMotion1 = new javax.swing.JLabel();
        jLabel_HumanMotion2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("X80 Control Demo");
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Robot Connection"));
        jPanel1.setName("Robot Connection");
        jLabel1.setText("Robot IP:");

        jTextField_RobotIP.setText("192.168.0.213");

        jLabel2.setText("Robot Port:");

        jTextField_RobotPort.setText("10001");

        jButton_Connect.setText("Connect");
        jButton_Connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_ConnectActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(106, Short.MAX_VALUE)
                .addComponent(jLabel1)
                .addGap(19, 19, 19)
                .addComponent(jTextField_RobotIP, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(36, 36, 36)
                .addComponent(jLabel2)
                .addGap(15, 15, 15)
                .addComponent(jTextField_RobotPort, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(75, 75, 75)
                .addComponent(jButton_Connect, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(89, 89, 89))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButton_Connect)
                .addComponent(jTextField_RobotPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel2)
                .addComponent(jTextField_RobotIP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel1))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Sensor Data"));
        jLabel_IR1.setText("IR #1");

        jLabel_IRDis1.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis1.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis1.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis1.setText("0.81");
        jLabel_IRDis1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR2.setText("IR #2");

        jLabel_IRDis2.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis2.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis2.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis2.setText("0.81");
        jLabel_IRDis2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR3.setText("IR #3");

        jLabel_IRDis3.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis3.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis3.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis3.setText("0.81");
        jLabel_IRDis3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR4.setText("IR #4");

        jLabel_IRDis4.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis4.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis4.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis4.setText("0.81");
        jLabel_IRDis4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR5.setText("IR #5");

        jLabel_IRDis5.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis5.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis5.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis5.setText("0.81");
        jLabel_IRDis5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR6.setText("IR #6");

        jLabel_IRDis6.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis6.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis6.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis6.setText("0.81");
        jLabel_IRDis6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_IR7.setText("IR #7");

        jLabel_IRDis7.setBackground(new java.awt.Color(0, 0, 0));
        jLabel_IRDis7.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_IRDis7.setForeground(new java.awt.Color(0, 255, 51));
        jLabel_IRDis7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_IRDis7.setText("0.81");
        jLabel_IRDis7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US1.setText("US #1");

        jLabel_USDis1.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis1.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis1.setText("2.55");
        jLabel_USDis1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US2.setText("US #2");

        jLabel_USDis2.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis2.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis2.setText("2.55");
        jLabel_USDis2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US3.setText("US #3");

        jLabel_USDis3.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis3.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis3.setText("2.55");
        jLabel_USDis3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US4.setText("US #4");

        jLabel_USDis4.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis4.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis4.setText("2.55");
        jLabel_USDis4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US5.setText("US #5");

        jLabel_USDis5.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis5.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis5.setText("2.55");
        jLabel_USDis5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_US6.setText("US #6");

        jLabel_USDis6.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_USDis6.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_USDis6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_USDis6.setText("2.55");
        jLabel_USDis6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_BoardVolDec.setText("Board Vol:");

        jLabel_BoardVol.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_BoardVol.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_BoardVol.setText("0.00");

        jLabel_MotorVolDec.setText("Motor Vol:");

        jLabel_MotorVol.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_MotorVol.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_MotorVol.setText("0.00");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel_IR1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel_IRDis1, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel_US1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel_USDis1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel_IR2)
                            .addComponent(jLabel_US2))
                        .addGap(8, 8, 8)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel_IRDis2, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addComponent(jLabel_MotorVolDec))
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addComponent(jLabel_US3)
                                            .addComponent(jLabel_IR3))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGap(10, 10, 10)
                                                .addComponent(jLabel_USDis3)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(jLabel_US4))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel_IRDis3, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabel_IR4))))))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel_USDis2))))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel_BoardVolDec)
                        .addGap(14, 14, 14)
                        .addComponent(jLabel_BoardVol, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_IRDis4, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel_USDis4)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel_IR5)
                            .addComponent(jLabel_US5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_IRDis5, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel_USDis5)))
                        .addGap(6, 6, 6)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_IR6)
                            .addComponent(jLabel_US6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel_IRDis6, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel_IR7)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel_IRDis7, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel_USDis6))))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(jLabel_MotorVol, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(36, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel_IR1)
                    .addComponent(jLabel_IRDis1)
                    .addComponent(jLabel_IR2)
                    .addComponent(jLabel_IRDis2)
                    .addComponent(jLabel_IR3)
                    .addComponent(jLabel_IRDis3)
                    .addComponent(jLabel_IR4)
                    .addComponent(jLabel_IRDis4)
                    .addComponent(jLabel_IR5)
                    .addComponent(jLabel_IRDis5)
                    .addComponent(jLabel_IR6)
                    .addComponent(jLabel_IRDis6)
                    .addComponent(jLabel_IR7)
                    .addComponent(jLabel_IRDis7))
                .addGap(14, 14, 14)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel_US1)
                    .addComponent(jLabel_USDis1)
                    .addComponent(jLabel_US2)
                    .addComponent(jLabel_USDis2)
                    .addComponent(jLabel_US3)
                    .addComponent(jLabel_USDis3)
                    .addComponent(jLabel_US4)
                    .addComponent(jLabel_US5)
                    .addComponent(jLabel_USDis4)
                    .addComponent(jLabel_USDis5)
                    .addComponent(jLabel_US6)
                    .addComponent(jLabel_USDis6))
                .addGap(13, 13, 13)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel_BoardVolDec)
                    .addComponent(jLabel_BoardVol)
                    .addComponent(jLabel_MotorVolDec)
                    .addComponent(jLabel_MotorVol)))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor Sensor"));
        jLabel3.setText("Left Motor");

        jLabel4.setText("Right Motor");

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setText("EncoderPos");

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("EncodeSpeed");

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("Current");

        jLabel_LeftMotorPos.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_LeftMotorPos.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_LeftMotorPos.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_LeftMotorPos.setText("32767");
        jLabel_LeftMotorPos.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_RightMotorPos.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_RightMotorPos.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_RightMotorPos.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_RightMotorPos.setText("32767");
        jLabel_RightMotorPos.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel_LeftMotorSpeed.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_LeftMotorSpeed.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_LeftMotorSpeed.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_LeftMotorSpeed.setText("500");

        jLabel_RightMotorSpeed.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_RightMotorSpeed.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_RightMotorSpeed.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_RightMotorSpeed.setText("500");

        jLabel_LeftMotorCurrent.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_LeftMotorCurrent.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_LeftMotorCurrent.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_LeftMotorCurrent.setText("0.00");

        jLabel_RightMotorCurrent.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_RightMotorCurrent.setForeground(new java.awt.Color(0, 255, 0));
        jLabel_RightMotorCurrent.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_RightMotorCurrent.setText("0.00");

        jLabel16.setText("jLabel16");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addComponent(jLabel16)
                        .addComponent(jLabel3)))
                .addGap(63, 63, 63)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jLabel_RightMotorPos, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel_LeftMotorPos, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 52, Short.MAX_VALUE)))
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel3Layout.createSequentialGroup()
                            .addGap(57, 57, 57)
                            .addComponent(jLabel_LeftMotorSpeed)
                            .addGap(39, 39, 39))
                        .addGroup(jPanel3Layout.createSequentialGroup()
                            .addGap(17, 17, 17)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel_RightMotorSpeed, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(23, 23, 23)))
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel_LeftMotorCurrent, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel_RightMotorCurrent, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(22, 22, 22))))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel5)
                            .addComponent(jLabel7)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel3)
                        .addComponent(jLabel_LeftMotorPos)
                        .addComponent(jLabel_LeftMotorSpeed))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel_LeftMotorCurrent)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel4)
                        .addComponent(jLabel_RightMotorPos)
                        .addComponent(jLabel_RightMotorSpeed))
                    .addComponent(jLabel_RightMotorCurrent))
                .addContainerGap())
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Motor Control"));
        jButton_MoveForward.setText("^");
        jButton_MoveForward.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton_MoveForward.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButton_MoveForward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_MoveForwardActionPerformed(evt);
            }
        });

        jButton_TurnLeft.setText("<");
        jButton_TurnLeft.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton_TurnLeft.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButton_TurnLeft.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_TurnLeftActionPerformed(evt);
            }
        });

        jButton_Stop.setText("O");
        jButton_Stop.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton_Stop.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButton_Stop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_StopActionPerformed(evt);
            }
        });

        jButton_TurnRight.setText(">");
        jButton_TurnRight.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton_TurnRight.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButton_TurnRight.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_TurnRightActionPerformed(evt);
            }
        });

        jButton_MoveBackward.setText("v");
        jButton_MoveBackward.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton_MoveBackward.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButton_MoveBackward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_MoveBackwardActionPerformed(evt);
            }
        });

        jLabel8.setText("SpeedGear:");

        jSlider_Speed.setMaximum(1200);
        jSlider_Speed.setOrientation(javax.swing.JSlider.VERTICAL);
        jSlider_Speed.setValue(400);
        jSlider_Speed.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_SpeedStateChanged(evt);
            }
        });
        jSlider_Speed.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jSlider_SpeedPropertyChange(evt);
            }
        });
        jSlider_Speed.addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
                jSlider_SpeedAncestorAdded(evt);
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
            }
        });

        jLabel_Speed.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_Speed.setLabelFor(jSlider_Speed);
        jLabel_Speed.setText("400");

        jButton_MotorDemo.setText("Demo");
        jButton_MotorDemo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_MotorDemoActionPerformed(evt);
            }
        });

        jLabel9.setText("DemoStep");

        jLabel_DCMotorDemoStep.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_DCMotorDemoStep.setText("0");

        jButton_Forward.setText("F_Step");
        jButton_Forward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_ForwardActionPerformed(evt);
            }
        });

        jButton_Turn90.setText("Turn_90");
        jButton_Turn90.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Turn90ActionPerformed(evt);
            }
        });

        jTextField_PosKd.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_PosKd.setText("30");

        jTextField_PosKi.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_PosKi.setText("10000");

        jTextField_PosKp.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_PosKp.setText("1500");

        jButton1.setText("PosPID");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel10.setText("Kp");

        jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel21.setText("Kd");

        jLabel22.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel22.setText("Ki");

        jTextField_VelKi.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_VelKi.setText("0");

        jTextField_VelKd.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_VelKd.setText("5");

        jTextField_VelKp.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField_VelKp.setText("10");

        jButton2.setText("VelocityPID");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addComponent(jButton_TurnLeft, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton_MoveForward, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jButton_Stop, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_TurnRight, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButton_MoveBackward, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(26, 26, 26)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel_Speed, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSlider_Speed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton_MotorDemo, javax.swing.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .addComponent(jButton_Turn90, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton_Forward, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel_DCMotorDemoStep, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9))
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(17, 17, 17)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField_PosKp, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField_VelKp, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField_PosKd, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField_VelKd, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField_VelKi, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField_PosKi, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton2)))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(65, 65, 65)
                                .addComponent(jLabel22, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSlider_Speed, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jButton_MoveForward)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton_Stop)
                            .addComponent(jButton_TurnLeft)
                            .addComponent(jButton_TurnRight)
                            .addComponent(jLabel8))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton_MoveBackward)
                            .addComponent(jLabel_Speed)))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jButton_MotorDemo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_Forward)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton_Turn90))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel9)
                            .addComponent(jLabel10)
                            .addComponent(jLabel21)
                            .addComponent(jLabel22))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jTextField_PosKi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextField_PosKd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextField_PosKp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jButton1))
                                .addGap(19, 19, 19)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jTextField_VelKi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextField_VelKd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextField_VelKp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jButton2)))
                            .addComponent(jLabel_DCMotorDemoStep))))
                .addContainerGap(28, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Servo Control(Head)"));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel11.setText("Head Tilt:");

        jSlider_HeadTilt.setMaximum(7000);
        jSlider_HeadTilt.setMinimum(200);
        jSlider_HeadTilt.setOrientation(javax.swing.JSlider.VERTICAL);
        jSlider_HeadTilt.setValue(3500);
        jSlider_HeadTilt.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_HeadTiltStateChanged(evt);
            }
        });

        jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel12.setText("Eye Tilt:");

        jSlider_EyeTilt.setMaximum(7000);
        jSlider_EyeTilt.setMinimum(200);
        jSlider_EyeTilt.setOrientation(javax.swing.JSlider.VERTICAL);
        jSlider_EyeTilt.setValue(3500);
        jSlider_EyeTilt.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_EyeTiltStateChanged(evt);
            }
        });

        jLabel13.setText("Mouth:");

        jSlider_Mouth.setMaximum(7000);
        jSlider_Mouth.setMinimum(200);
        jSlider_Mouth.setOrientation(javax.swing.JSlider.VERTICAL);
        jSlider_Mouth.setValue(4000);
        jSlider_Mouth.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_MouthStateChanged(evt);
            }
        });

        jLabel14.setText("HeadPan:");

        jSlider_HeadPan.setMaximum(7000);
        jSlider_HeadPan.setMinimum(200);
        jSlider_HeadPan.setValue(3500);
        jSlider_HeadPan.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_HeadPanStateChanged(evt);
            }
        });

        jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel15.setText("EyePan:");

        jSlider_EyePan.setMaximum(7000);
        jSlider_EyePan.setMinimum(200);
        jSlider_EyePan.setValue(3500);
        jSlider_EyePan.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider_EyePanStateChanged(evt);
            }
        });

        jButton_HeadDemo.setText("Demo");
        jButton_HeadDemo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_HeadDemoActionPerformed(evt);
            }
        });

        jLabel23.setText("DemoStep");

        jLabel_ServoDemoStep.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_ServoDemoStep.setText("0");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel14)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(39, 39, 39)
                        .addComponent(jSlider_HeadTilt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jSlider_HeadPan, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSlider_EyeTilt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(79, 79, 79)
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                        .addComponent(jSlider_Mouth, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(16, 16, 16)
                                .addComponent(jLabel_ServoDemoStep, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(27, 27, 27)
                                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel23)
                                    .addComponent(jButton_HeadDemo)))))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(41, 41, 41)
                        .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSlider_EyePan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(53, 53, 53)
                                .addComponent(jLabel11))
                            .addComponent(jSlider_HeadTilt, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(47, 47, 47)
                                .addComponent(jLabel13))
                            .addComponent(jSlider_Mouth, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(56, 56, 56)
                                .addComponent(jLabel12))
                            .addComponent(jSlider_EyeTilt, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jSlider_EyePan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15)
                            .addComponent(jLabel14)
                            .addComponent(jSlider_HeadPan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addComponent(jButton_HeadDemo)
                        .addGap(12, 12, 12)
                        .addComponent(jLabel23)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel_ServoDemoStep)))
                .addContainerGap())
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Human Sensor"));
        jPanel6.setName("");
        jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel17.setText("Left");
        jLabel17.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel18.setText("Right");

        jLabel19.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel19.setText("Alarm");

        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel20.setText("Motion");

        jLabel_HumanAlarm1.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_HumanAlarm1.setForeground(new java.awt.Color(102, 255, 102));
        jLabel_HumanAlarm1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_HumanAlarm1.setText("0");

        jLabel_HumanAlarm2.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_HumanAlarm2.setForeground(new java.awt.Color(102, 255, 102));
        jLabel_HumanAlarm2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_HumanAlarm2.setText("0");

        jLabel_HumanMotion1.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_HumanMotion1.setForeground(new java.awt.Color(102, 255, 102));
        jLabel_HumanMotion1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_HumanMotion1.setText("0");

        jLabel_HumanMotion2.setFont(new java.awt.Font("Tahoma", 3, 11));
        jLabel_HumanMotion2.setForeground(new java.awt.Color(102, 255, 102));
        jLabel_HumanMotion2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_HumanMotion2.setText("0");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE)))
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addComponent(jLabel19)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel_HumanAlarm1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 47, Short.MAX_VALUE)
                            .addComponent(jLabel_HumanAlarm2, javax.swing.GroupLayout.DEFAULT_SIZE, 47, Short.MAX_VALUE))))
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGap(39, 39, 39)
                        .addComponent(jLabel20))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel_HumanMotion2, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel_HumanMotion1, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(32, 32, 32))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19)
                    .addComponent(jLabel20))
                .addGap(5, 5, 5)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel17)
                    .addComponent(jLabel_HumanAlarm1)
                    .addComponent(jLabel_HumanMotion1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18)
                    .addComponent(jLabel_HumanAlarm2)
                    .addComponent(jLabel_HumanMotion2))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 413, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(22, 22, 22)
                            .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton_HeadDemoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_HeadDemoActionPerformed
// TODO add your handling code here:
        ServoTimeCtrAll(3500,3200,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,2000);
        ServoDemoStep = 0;
        tmrServoDemo.start();
    }//GEN-LAST:event_jButton_HeadDemoActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
        int kp = Integer.parseInt(jTextField_VelKp.getText());
        int kd = Integer.parseInt(jTextField_VelKd.getText());
        int ki = Integer.parseInt(jTextField_VelKi.getText());
        SetDcMotorVelocityControlPID((byte)0,kp,kd,ki);
        SetDcMotorVelocityControlPID((byte)1,kp,kd,ki);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
        int kp = Integer.parseInt(jTextField_PosKp.getText());
        int kd = Integer.parseInt(jTextField_PosKd.getText());
        int ki = Integer.parseInt(jTextField_PosKi.getText());
        SetDcMotorPositionControlPID((byte)0,kp,kd,ki);
        try{
            Thread.sleep(10);
        }catch (InterruptedException ex){
            
        }
        SetDcMotorPositionControlPID((byte)1,kp,kd,ki);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton_Turn90ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Turn90ActionPerformed
// TODO add your handling code here:
         turnStep(-90.0);
    }//GEN-LAST:event_jButton_Turn90ActionPerformed

    private void jButton_ForwardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_ForwardActionPerformed
// TODO add your handling code here:
        //forward 1m
        runStep(1.5);
    }//GEN-LAST:event_jButton_ForwardActionPerformed

    private void jButton_MotorDemoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_MotorDemoActionPerformed
    // TODO add your handling code here:
        //start demo timer
        DCMotorDemoStep = 0;
        jLabel_DCMotorDemoStep.setText(Integer.toString(DCMotorDemoStep));
        runStep(1.0);
        tmrDCMotorDemo.start();
        
    }//GEN-LAST:event_jButton_MotorDemoActionPerformed

    private void jSlider_MouthStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_MouthStateChanged
// TODO add your handling code here:
        //servo time control, channel 4
        int time = 1000;        //1000ms execute time
        int cmdValue = jSlider_EyePan.getValue();
        byte channel = 4;
        ServoTimeCtrl(channel,cmdValue,time);
    }//GEN-LAST:event_jSlider_MouthStateChanged

    private void jSlider_EyeTiltStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_EyeTiltStateChanged
// TODO add your handling code here:
        //servo time control, channel 3
        int time = 1000;        //1000ms execute time
        int cmdValue = jSlider_EyePan.getValue();
        byte channel = 3;
        ServoTimeCtrl(channel,cmdValue,time);
    }//GEN-LAST:event_jSlider_EyeTiltStateChanged

    private void jSlider_EyePanStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_EyePanStateChanged
// TODO add your handling code here:
        //servo time control, channel 2
        int time = 1000;        //1000ms execute time
        int cmdValue = jSlider_EyePan.getValue();
        byte channel = 2;
        ServoTimeCtrl(channel,cmdValue,time);
    }//GEN-LAST:event_jSlider_EyePanStateChanged

    private void jSlider_HeadTiltStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_HeadTiltStateChanged
// TODO add your handling code here:
        //servo time control, channel 1
        int time = 1000;        //1000ms execute time
        int cmdValue = jSlider_HeadTilt.getValue();
        byte channel = 0;
        ServoTimeCtrl(channel,cmdValue,time);
    }//GEN-LAST:event_jSlider_HeadTiltStateChanged

    private void jSlider_HeadPanStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_HeadPanStateChanged
// TODO add your handling code here:
        //servo time control, channel 0
        int time = 1000;        //1000ms execute time
        int cmdValue = jSlider_HeadPan.getValue();
        byte channel = 1;
        ServoTimeCtrl(channel,cmdValue,time);
        
    }//GEN-LAST:event_jSlider_HeadPanStateChanged

    private void jButton_StopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_StopActionPerformed
// TODO add your handling code here:
        byte channel = 0;
        DisableDCMotor(channel);
        channel = 1;
        DisableDCMotor(channel);
    }//GEN-LAST:event_jButton_StopActionPerformed

    private void jButton_MoveBackwardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_MoveBackwardActionPerformed
// TODO add your handling code here:
         int speed = Integer.parseInt(jLabel_Speed.getText());
         SpeedNonTimeCtrlAll(speed, -speed, NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD);
        
        
        
    }//GEN-LAST:event_jButton_MoveBackwardActionPerformed

    private void jButton_TurnLeftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_TurnLeftActionPerformed
// TODO add your handling code here:
        int speed = Integer.parseInt(jLabel_Speed.getText());
        SpeedNonTimeCtrlAll(speed, speed, NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD);
    }//GEN-LAST:event_jButton_TurnLeftActionPerformed

    private void jButton_TurnRightActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_TurnRightActionPerformed
// TODO add your handling code here:
        int speed = Integer.parseInt(jLabel_Speed.getText());
        SpeedNonTimeCtrlAll(-speed, -speed, NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD);
    }//GEN-LAST:event_jButton_TurnRightActionPerformed

    private void jButton_MoveForwardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_MoveForwardActionPerformed
// TODO add your handling code here:
        int speed = Integer.parseInt(jLabel_Speed.getText());
        SpeedNonTimeCtrlAll(-speed, +speed, NONCTRLCMD,NONCTRLCMD,NONCTRLCMD,NONCTRLCMD);
    }//GEN-LAST:event_jButton_MoveForwardActionPerformed

    private byte calc_CRC_bit(byte []CmdArray){
        byte shift_reg,sr_lsb,data_bit,v;
        int i,j;
        byte fb_bit;
        shift_reg = 0;      //initialize the shift register
        for(i = 0; i < CmdArray.length - 5; i ++){
            v = (byte)(CmdArray[2 + i]);                          //start from RID
            for(j = 0; j < 8; j++){      //for each bit
                data_bit = (byte)((v & 0x01) & 0xff);                        //isolate least sign bit   
                sr_lsb = (byte)((shift_reg & 0x01) & 0xff);
                fb_bit = (byte)(((data_bit ^ sr_lsb) & 0x01) & 0xff);                //calculate the feed back bit
                shift_reg = (byte)((shift_reg & 0xff)>>> 1);
                if (fb_bit == 1){
                       shift_reg = (byte)((shift_reg ^ 0x8c) & 0xff);
                }
                v = (byte)((v & 0xff) >>> 1);
            }
        }
        return shift_reg;
    }
    
    private void jSlider_SpeedStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider_SpeedStateChanged
// TODO add your handling code here:
         jLabel_Speed.setText(Integer.toString(jSlider_Speed.getValue()));
    }//GEN-LAST:event_jSlider_SpeedStateChanged

    private void jSlider_SpeedPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jSlider_SpeedPropertyChange
    }//GEN-LAST:event_jSlider_SpeedPropertyChange

    private void jSlider_SpeedAncestorAdded(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_jSlider_SpeedAncestorAdded

    }//GEN-LAST:event_jSlider_SpeedAncestorAdded

    private void jButton_ConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_ConnectActionPerformed
// TODO add your handling code here:
            robotIP = jTextField_RobotIP.getText();
            robotPort = Integer.parseInt(jTextField_RobotPort.getText());
            sock = new robotSocket(robotIP, robotPort);
            ConnectFlag = true;
            sock.run();
            
    }//GEN-LAST:event_jButton_ConnectActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new X80ControlDemo().setVisible(true);
                 
        };
        
        
        });
     }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton_Connect;
    private javax.swing.JButton jButton_Forward;
    private javax.swing.JButton jButton_HeadDemo;
    private javax.swing.JButton jButton_MotorDemo;
    private javax.swing.JButton jButton_MoveBackward;
    private javax.swing.JButton jButton_MoveForward;
    private javax.swing.JButton jButton_Stop;
    private javax.swing.JButton jButton_Turn90;
    private javax.swing.JButton jButton_TurnLeft;
    private javax.swing.JButton jButton_TurnRight;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel_BoardVol;
    private javax.swing.JLabel jLabel_BoardVolDec;
    private javax.swing.JLabel jLabel_DCMotorDemoStep;
    private javax.swing.JLabel jLabel_HumanAlarm1;
    private javax.swing.JLabel jLabel_HumanAlarm2;
    private javax.swing.JLabel jLabel_HumanMotion1;
    private javax.swing.JLabel jLabel_HumanMotion2;
    private javax.swing.JLabel jLabel_IR1;
    private javax.swing.JLabel jLabel_IR2;
    private javax.swing.JLabel jLabel_IR3;
    private javax.swing.JLabel jLabel_IR4;
    private javax.swing.JLabel jLabel_IR5;
    private javax.swing.JLabel jLabel_IR6;
    private javax.swing.JLabel jLabel_IR7;
    private javax.swing.JLabel jLabel_IRDis1;
    private javax.swing.JLabel jLabel_IRDis2;
    private javax.swing.JLabel jLabel_IRDis3;
    private javax.swing.JLabel jLabel_IRDis4;
    private javax.swing.JLabel jLabel_IRDis5;
    private javax.swing.JLabel jLabel_IRDis6;
    private javax.swing.JLabel jLabel_IRDis7;
    private javax.swing.JLabel jLabel_LeftMotorCurrent;
    private javax.swing.JLabel jLabel_LeftMotorPos;
    private javax.swing.JLabel jLabel_LeftMotorSpeed;
    private javax.swing.JLabel jLabel_MotorVol;
    private javax.swing.JLabel jLabel_MotorVolDec;
    private javax.swing.JLabel jLabel_RightMotorCurrent;
    private javax.swing.JLabel jLabel_RightMotorPos;
    private javax.swing.JLabel jLabel_RightMotorSpeed;
    private javax.swing.JLabel jLabel_ServoDemoStep;
    private javax.swing.JLabel jLabel_Speed;
    private javax.swing.JLabel jLabel_US1;
    private javax.swing.JLabel jLabel_US2;
    private javax.swing.JLabel jLabel_US3;
    private javax.swing.JLabel jLabel_US4;
    private javax.swing.JLabel jLabel_US5;
    private javax.swing.JLabel jLabel_US6;
    private javax.swing.JLabel jLabel_USDis1;
    private javax.swing.JLabel jLabel_USDis2;
    private javax.swing.JLabel jLabel_USDis3;
    private javax.swing.JLabel jLabel_USDis4;
    private javax.swing.JLabel jLabel_USDis5;
    private javax.swing.JLabel jLabel_USDis6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JSlider jSlider_EyePan;
    private javax.swing.JSlider jSlider_EyeTilt;
    private javax.swing.JSlider jSlider_HeadPan;
    private javax.swing.JSlider jSlider_HeadTilt;
    private javax.swing.JSlider jSlider_Mouth;
    private javax.swing.JSlider jSlider_Speed;
    private javax.swing.JTextField jTextField_PosKd;
    private javax.swing.JTextField jTextField_PosKi;
    private javax.swing.JTextField jTextField_PosKp;
    private javax.swing.JTextField jTextField_RobotIP;
    private javax.swing.JTextField jTextField_RobotPort;
    private javax.swing.JTextField jTextField_VelKd;
    private javax.swing.JTextField jTextField_VelKi;
    private javax.swing.JTextField jTextField_VelKp;
    // End of variables declaration//GEN-END:variables
    
}
