/*
 * robotSocket.java
 *
 * Created on July 26, 2007, 10:12 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


package DrRobot.X80Control;
import java.io.*;
import java.net.*;
/**
 *
 * @author Bo Wei
 */
public class robotSocket extends Thread{
    private DatagramSocket sock = null;
    private String robotip;
    private int robotport;
    private DatagramPacket recPacket = null;
    private DatagramPacket sendPacket = null;
    private InetAddress server = null;
    
    private byte []recBuffer;
    private byte []sendBuffer;
    private int []tempData;

    
    private ByteArrayInputStream bin = null;
    private DataInputStream din = null;
    private DataOutputStream out = null;
    private InputStream in = null;
    private BufferedReader reader = null;
    private String strCommand = "";
    
    public int []EncoderPos = {0,0};
    public double []IRDis = {1.0,2.0,3.0,4.0,5.0,6.0,7.0};
    //motor sensor 
   
    public int []EncoderSpeed = {0,0};
    public double []MotorCurrent = {0.0,0.0};
    
    //custom sensor data
    public int []customAD = {0,0,0,0,0,0,0,0};
    public int customIO = 0;
    
    //standard sensor data
    public double []USDis = {0,0,0,0,0,0};
    public int []HumanAlarm = {0,0};
    public int []HumanMotion = {0,0};
    public int IRRange = 0;
    public double BoardVol = 0;
    public double DCMotorVol = 0;
    
    
    /** Creates a new instance of robotSocket */
    public robotSocket(String robotIP, int robotPort) {
    
        
        this.robotip = robotIP;
        this.robotport = robotPort;
        try{
            server = InetAddress.getByName(robotip);
        }catch(IOException e) {
            e.printStackTrace();
	    System.exit(3);
           return;
        }
                
        //socket connect
        try {
	    
            sock = new DatagramSocket();
            sock.setSoTimeout(20);
	} catch(IOException e) {
 	    e.printStackTrace();
	    System.exit(3);
           return;
	}
        
        recBuffer = new byte[1024];
        recPacket = new DatagramPacket(recBuffer,recBuffer.length);
        
        sendBuffer = new byte[256];
        sendPacket = new DatagramPacket(sendBuffer,sendBuffer.length,server,robotport);
        try{
            sock.send(sendPacket);
        }catch(IOException e){
            e.printStackTrace();
        }
        
        
        
        
    
    }
   public void run(){
            
                try{
                    sock.setSoTimeout(10);
                    sock.receive(recPacket);    
                }catch(IOException e){
                    e.printStackTrace();
                    
                }
                int Len = recPacket.getLength();
                if (Len != 0) {
                    //decode here
                    tempData = new int[Len];
                    for (int i = 0; i < Len; i ++){
                        tempData[i] = (int)(recBuffer[i] & 0xff);
                    }
                    if ( (tempData[0] == 94) && (tempData[1] == 2) && (tempData[Len-2] == 94) && (tempData[Len-1] == 13)){
                        //here is a whole package
                        //first motor sensor data, please refere protocol
                        if (tempData[4] == 123){
                            EncoderPos[0] = tempData[5 + 25] +(tempData[5 + 26]) * 256;
                            EncoderSpeed[0] = tempData[5 + 27] +(tempData[5 + 28]) * 256;
                            EncoderPos[1] = tempData[5 + 29] +(tempData[5 + 30]) * 256;
                            EncoderSpeed[1] = tempData[5 + 31] +(tempData[5 + 32]) * 256;
                            
                            MotorCurrent[0] =  (double) ( tempData[5 + 13] +(tempData[5 + 14]) * 256)/((double)728.0);
                            MotorCurrent[1] = (double)(tempData[5 + 15] +(tempData[5 + 16]) * 256)/((double)728.0);
                        }
                        else if(tempData[4] == 124){
                            //custom sensor data
                            for (int i = 0; i < 8; i ++){
                                customAD[i] = tempData[ 6 + 2*i] + tempData[6 + 2*i +1] * 256;    
                            }
                            
                            customIO = tempData[5 + 17];
                        }
                        else if(tempData[4] == 125){
                            //standard sensor
                            for (int i = 0; i < 6; i++){
                                USDis[i] = (double)(tempData[6 + i]) / 100.0;    
                            }
                            HumanAlarm[0] = tempData[5 + 7] + tempData[5 + 8] * 256;
                            HumanMotion[0] = tempData[5 + 9] + tempData[5 + 10] * 256; 
                            HumanAlarm[1] = tempData[5 + 11] + tempData[5 + 12] * 256;
                            HumanMotion[1] = tempData[5 + 13] + tempData[5 + 14] * 256; 
                            IRRange = (tempData[5 + 25] + tempData[5 + 26] * 256);
                            BoardVol = (double)(tempData[5 + 31] + tempData[5 + 32] * 256)/ 4095.0 * 9.0;
                            DCMotorVol = (double)(tempData[5 + 33] + tempData[5 + 34] * 256)/ 4095.0 * 24.0;
                        }
                        
                    }
                    IRDis[0] = AD2Dis(IRRange);
                    for (int i = 1; i < 7; i ++){
                        IRDis[i] = AD2Dis(customAD[i+1]);    
                    }
                    
                    
                    recPacket.setLength(recBuffer.length);
                }
            
      }
    
   
      public void sendCommand(byte []CmdArray){
          for (int i = 0; i< CmdArray.length ; i ++){
              sendBuffer[i] = CmdArray[i];
          }
         sendPacket = new DatagramPacket(sendBuffer,sendBuffer.length,server,robotport);
        try{
            sock.send(sendPacket);
        }catch(IOException e){
            e.printStackTrace();
        }
      }
   
      private double AD2Dis(int ADValue){
        double Dis = 0;
        if ((ADValue > 4095) ||(ADValue <= 0)){
            Dis = 0;
        }
        else{
            Dis = 21.6 /( (double)(ADValue) * 3.0 / 4028 - 0.17);
            if (Dis > 80){
                Dis = 0.81;
            }
            else if ((Dis < 10) ){
                Dis = 0.09;
            }
            else{
                Dis = Dis / 100.0;
            }
        }
        return Dis;
      }
      

   
}
